#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 2.0
# date: 6-25-99
#
# Copyright 1999-2000, Cobalt Networks, Inc
# All rights reserved

# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# Not good to be used in setup wizard
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

package Cobalt::UI::admin;

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::User;
use Cobalt::Group;
use Cobalt::List;
use Cobalt::Vacation;
use Cobalt::Netutil;

use DB_File;
use Fcntl qw(O_RDWR O_CREAT);
use strict;
use Locale::gettext;

# global variables
use vars qw( $DEBUG );
my ($q, $page, $locale, $button_style, $header_style, $table_style, $button_style, $header_style );
my $scriptURL="/cgi-bin/.cobalt/turbo_ui/dispatch/admin";

sub main {

$DEBUG = 0;

$q=shift;

$locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale();
  $button_style=$locale->getProperty("buttonStyle");
  $header_style=$locale->getProperty("headerStyle");
  $table_style=$locale->getProperty("tableStyle");
 }

my $forbiddenURL="/.cobalt/error/forbidden.html";
my $user = $ENV{REMOTE_USER};
unless (user_authok($user, "admin")) {
    print "location: $forbiddenURL\n\n";
    die "Unauthoried access by $user, not an admin.\n";
}

# the page that run this script
$page=$q->param( 'page' );

if( $page eq 'adminmain' ) {
  print STDERR "handle 1" if ($DEBUG);
  handleAdminPage( $user ); }
else {
  print STDERR "handle 2" if ($DEBUG);
  genAdminPage( \*STDOUT );
}

  undef ($q, $page, $locale );
}

#
# event handler for admin page
#
sub handleAdminPage {
    my $user = shift;

    # read form input
    my $fullName=$q->param( 'fullname' );
    my $password1=$q->param( 'password1' );
    my $password2=$q->param( 'password2' );
    my $email=$q->param( 'email' );

    # alteradmin fields
    my $alter_exist = Cobalt::User::user_get_alteradmin();
    my $su=$q->param( 'su' );
    my $su1=$q->param( 'su1' );
    my $su2=$q->param( 'su2' );

    my $err=0;
    my $info;
    my $flav='error';

    # error check
    my @passwordInBytes=unpack( 'C*', $password1 );
    my $passwordBadChar=0;
    my ($byte, $nopasswd);
    foreach $byte ( @passwordInBytes ) {
	if( $byte>127 ) { $passwordBadChar=1; last; }
    }

    if( !$fullName ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "noFullName")."\"");
	$err=1;
    }
    #elsif( $fullName=~/\'/o || $fullName=~/\"/o ) {
    elsif( $fullName=~/\"/ ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "noQuotesInFullName")."\"");
	$err=1;
    }
    elsif( ( $password1 && !$password2 ) || ( !$password1 && $password2 ) ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "noPasswords")."\"");
	$err=1;
    }
    elsif( $password1 ne $password2 ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "passwordsNotMatch")."\"");
	$err=1;
    }
    elsif( $passwordBadChar ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "passwordBadChar")."\"");
	$err=1;
    }
    else {
	# everything is fine
	my $ret=user_mod( $Adminuser, $fullName, $password1, 0 );

	if( $ret!~/^2/ ) {
	    $info.=substr( $ret, 4 );
	    $err=1;
	}
	else {
	    # update sys list
            if ($email) {
                $ret=alias_set( $AlertList, $Adminuser, $email );
            }
            else {
                $ret=alias_set( $AlertList, $Adminuser);
            }
	    if( $ret!~/^2/ ) {
		$info.=substr( $ret, 4 ).'<BR>';
		$err=1;
	    }
	}

	# [un]set the alteradmin account
	if($user eq $Alteradmin) {
		Cobalt::User::user_set_alteradmin($su, $su1);
	} elsif(!$alter_exist) {
		Cobalt::User::user_set_alteradmin($su, $su1);
	}
    }

    if( $err ) {
	genAdminPage( \*STDOUT, $info, $flav );
    }
    else {
	print "location: $scriptURL\n\n";	
    }
}

#
# argument 0 is the file handle the page goes to
# argument 1 is the information shown to user
#
sub genAdminPage {
    my ( $handle, $info, $flav )=@_;

    my $fullName=( user_show( $Adminuser ) )[ 1 ];
    my @aliases = Cobalt::List::alias_get($AlertList);
    if ($aliases[0] =~ /^[134]\S*\s/) {
	$info.=substr( $aliases[0], 4 ).'<BR>';
	@aliases = ();
    }
    my $email= join ', ', grep +($_ ne $Adminuser), @aliases;

    my $hideFirstLastStart='';
    my $hideFirstLastEnd='';
    if( !$locale->getProperty( 'firstLastName' ) ) {
	$hideFirstLastStart='<!-- ';
	$hideFirstLastEnd=' -->';
    }

    # Construct $Alteradmin user support
    # default alteradmin enable/set pw page
    my $altermenu = <<EOF;
<TR>
    <TD WIDTH="26">
    <CENTER><A HREF="javascript: top.showInfo( suHelp );" onMouseOver="status='[str.help]'; top.showInfo( suHelp ); return true;"><IMG SRC="/.cobalt/images/smallest_help_but" BORDER="0"></A></center>
    </TD>
    <TD WIDTH="240">
    <FONT STYLE=[FONTT]>&nbsp;&nbsp;[str.suPassword]</FONT>
    </TD>
    <TD WIDTH="234">   

    <TABLE BORDER=0 WIDTH=246>
    <TR><TD WIDTH="25" ROWSPAN="2" ALIGN="LEFT">
        <INPUT TYPE="CHECKBOX" NAME="su" CHECKED>
        </TD>
        <TD WIDTH="150" ALIGN="RIGHT"><FONT STYLE=[FONTT] SIZE="-1"><I>alteradmin</I> [str.password]</FONT>
        </TD>
        <TD WIDTH="75" ALIGN="LEFT">
        <INPUT TYPE="PASSWORD" NAME="su1" SIZE="8"></TD>
        </TD>
    </TR>
    <TR>
        <TD ALIGN="RIGHT"><FONT STYLE=[FONTT]>
        [str.again]<FONT>
        </TD>
        <TD ALIGN="LEFT">
        <INPUT TYPE="PASSWORD" NAME="su2" SIZE="8"></TD>
        </TD>
    </TR>
    </TABLE>

    </TD>
</TR>
EOF
    my $alterjs = <<EOF;
	if( f.su.checked ) {
                if( f.su1.value!=f.su2.value ) {
                        f.su2.focus();
                        top.showInfo( passwordNotMatch, 0, 'error' );
                        return false;
                }
                if( f.su1.value.length==0 ) {
                        f.su1.focus();
                        top.showInfo( suNoPassword, 0, 'error' );
                        return false;
                }
        }
EOF

    if((Cobalt::User::user_exist($Alteradmin)) && ($ENV{'REMOTE_USER'} ne $Alteradmin))  {
        # as user admin, illustrate (ro) that the alteradmin acct is enabled
        $altermenu = $alterjs = '';
    } elsif($ENV{'REMOTE_USER'} eq $AdminUser) {
  	$altermenu =~ s/CHECKED//g;
    } 

    # Read in the template
    open( TEMPLATE, "$Template_dir/admin.tmpl" )
	|| die "Cannot read $Template_dir/admin.tmpl: $!\n";

    my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
    my $charset = $locale->getProperty("http_Charset");
    my $charsetText;
    if ($charset) {
	$charsetText = "; charset=$charset";
    }
    print "Content-type:  text/html$charsetText\nCache-Control: no-cache\n\n";
    undef($charset, $charsetText);


    while( <TEMPLATE> ) {
	if(/\[/) {
	    s/\[ADMINUSER\]/$Adminuser/;
	    s/\[EMAIL\]/$email/;
	    s/\[FULLNAME\]/$fullName/;
	    s/\[HIDEFIRSTLASTEND\]/$hideFirstLastEnd/;
	    s/\[HIDEFIRSTLASTSTART\]/$hideFirstLastStart/;
	    s/\[SCRIPTURL\]/$scriptURL/;
	    s/\[USER_INFO\]/$info/;
	    s/\[FLAV\]/$flav/;
	    s/\[ALTERADMIN\]/$altermenu/;
	    s/\[SUJSCRIPT\]/$alterjs/;
            s/\[FONTH\]/$header_style/g;
            s/\[FONTT\]/$table_style/g;
            s/\[FONTB\]/$button_style/g;

	    s/\[str.([^\]]+)\]/eval("\"".Locale::gettext::dgettext("ui", "$1")."\"")/ge;
	}
	print $handle $_;
    }
    close TEMPLATE;
}
1;
