#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 2.0
# date: 7-4-99
#
# Copyright 1999-2000, Cobalt Networks, Inc
# All rights reserved

package Cobalt::UI::alertservice;

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::swatch;
use Cobalt::Util;
use Cobalt::User;

use Locale::gettext;

my ($q, $service, $locale, $button_style, $header_style, $table_style);

sub main {

$locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); 
                $button_style=$locale->getProperty("buttonStyle");
                $header_style=$locale->getProperty("headerStyle");
                $table_style=$locale->getProperty("tableStyle"); }

$q=shift;
$service = $q->param('service');

my $forbiddenURL="/.cobalt/error/forbidden.html";
my $user = $ENV{REMOTE_USER};
unless (user_authok($user, "admin")) {
    print "location: $forbiddenURL\n\n";
    die "Unauthorised access by $user, not an admin.\n";
}

my (@s,$title);
if ($service eq "email") {
    @s = ('pop3', 'imap', 'smtp');
    $title = MSG_get_ui("swatch_service_title_email");
} else {
    push @s, $service;
    $title = MSG_get_ui("swatch_service_title_" . $service);
}

my ($help,$jhelp,$defcon,$message,$body,$serv,$ball,$t,$since);
foreach $serv (@s) {
    $since = swatch_get_modify("service", $serv);
    $t = MSG_get_ui("swatch_service_title_" . $serv);
    $jhelp = $serv . "statusHelp";
    $help .= "var $jhelp=\'" . MSG_get_ui("swatch_service_help", $t) . "\';\n";
    $defcon = swatch_get_defcon("service", $serv);
    $defcon = ($defcon) ? ($defcon) : "0";
    $ball = $defcon_images{ $defcon };
    $message = MSG_get_ui("swatch_service_body_defcon_$defcon", $t, $since);

    $body .= <<END;
<TR>
    <TD WIDTH="26">
	<CENTER><A HREF="javascript: top.showInfo( $jhelp );" onMouseOver="status='[str.help]'; top.showInfo( $jhelp ); return true;"><IMG SRC="/.cobalt/images/smallest_help_but" ALIGN="BOTTOM" BORDER="0"></A></CENTER>
    </TD>
    <TD WIDTH="25">
        <P ALIGN="CENTER">$ball
    </TD>
    <TD WIDTH="449"><FONT COLOR="#FFFFFF">&nbsp;</FONT>
        <FONT STYLE="[FONTT]">$message</FONT>
    </TD>
</TR>
END
}

# Read in the template
open( TEMPLATE, "$Template_dir/service.tmpl" )
    || die "Cannot read $Template_dir/service.tmpl: $!\n";

    my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
    my $charset = $locale->getProperty("http_Charset");
    my $charsetText;
    if ($charset) {
	$charsetText = "; charset=$charset";
    }
    print "Content-type:  text/html$charsetText\nCache-Control: no-cache\n\n";
    undef($charset, $charsetText);


while ( <TEMPLATE> ) {
    s/\[HELP\]/$help/;
    s/\[TITLE\]/$title/;
    s/\[BODY\]/$body/;
    s/\[FONTH\]/$header_style/g;
    s/\[FONTT\]/$table_style/g;
    s/\[FONTB\]/$button_style/g;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/ge;

    print;
}

close TEMPLATE;

}
1;
