#!/usr/bin/perl

# author: Kevin K.M. Chiu , Timothy Stonis
#       Cobalt Networks
# version: 1.0
# date: 8/17/99 
#
# Copyright (C) 1999-2000, Cobalt Networks, Inc
# All rights reserved

package Cobalt::UI::arkeia;

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::User;
use Cobalt::Services;

use Locale::gettext;

# global variables
my ( $q, $locale, $page, $button_style, $header_style, $table_style );
my $arkeiaScriptURL='/cgi-bin/.cobalt/turbo_ui/dispatch/arkeia';
my $servicesScriptURL='/cgi-bin/.cobalt/turbo_ui/dispatch/services';

sub main {

$q=shift;
$page=$q->param( 'page' );
$locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale();
  $button_style=$locale->getProperty("buttonStyle");
  $header_style=$locale->getProperty("headerStyle");
  $table_style=$locale->getProperty("tableStyle");
 }

my $forbiddenURL="/.cobalt/error/forbidden.html";
my $user = $ENV{REMOTE_USER};
unless (user_authok($user, "admin")) {
    print "location: $forbiddenURL\n\n";
    die "Unauthoried access by $user, not an admin.\n";
}

if( $page ne 'arkeia' ) { genArkeiaPage( \*STDOUT ); }
else {
    my $err=0;
    my $info;
    my $flav = 'error';

    # read form input
    my $servername=$q->param( 'arkeiaserver' );

    if( $servername && ( $servername=~/\s/ ) ) {
	$info.=eval("\"".Locale::gettext::dgettext("ui", "ArkeiaServerNotValid")."\"");
	$err=1;
    }
    else {
	my $ret=Cobalt::Services::set_arkeia_servername( $servername );
	if( $ret!~/^2/o ) {
	    $info.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
    }

    if( !$err ) { print "location: $servicesScriptURL\n\n"; }
    else { genArkeiaPage( \*STDOUT, $info, $flav ); }
}

  undef ( $q, $locale, $page );
}

#
# argument 0 is the file handle the page goes to
# argument 1 is the infomation shown to user
#
sub genArkeiaPage {
    my ( $handle, $info, $flav )=@_;

    my ( $servername )=Cobalt::Services::get_arkeia_servername();

    # Read in the template
    open( TEMPLATE, "$Template_dir/arkeia.tmpl" )
          || die "Cannot read $Template_dir/arkeia.tmpl: $!\n";

    my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
    my $charset = $locale->getProperty("http_Charset");
    my $charsetText;
    if ($charset) {
	$charsetText = "; charset=$charset";
    }
    print "Content-type:  text/html$charsetText\nCache-Control: no-cache\n\n";
    undef($charset, $charsetText);

    while( <TEMPLATE> ) {
        s/\[SERVERNAME\]/$servername/o;
        s/\[SCRIPTURL\]/$arkeiaScriptURL/o;
        s/\[SERVICESSCRIPTURL\]/$servicesScriptURL/o;
        s/\[USER_INFO\]/$info/o;
        s/\[FLAV\]/$flav/o;
        s/\[FONTH\]/$header_style/go;
        s/\[FONTT\]/$table_style/go;
        s/\[FONTB\]/$button_style/go;

	s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

        print $handle $_;
    }
    close TEMPLATE;
}
1;
