#! /usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 2.0
# date: 7-01-99
#
# Copyright 1999-2000, Cobalt Networks, Inc
# All rights reserved

package Cobalt::UI::backupControl;

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::User;
use Cobalt::Util;

use Locale::gettext;

my ($q, $page, $locale);
my $backupControlURL="/cgi-bin/.cobalt/turbo_ui/dispatch/backupControl";

sub main {
# global variable
$q=shift;
$page=$q->param( 'page' );
$locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale();
                $button_style=$locale->getProperty("buttonStyle");
                $header_style=$locale->getProperty("headerStyle");
                $table_style=$locale->getProperty("tableStyle"); }

my $forbiddenURL="/.cobalt/error/forbidden.html";
my $user = $ENV{REMOTE_USER};
unless (user_authok($user, "admin")) {
    print "location: $forbiddenURL\n\n";
    die "Unauthorized access by $user, not an admin.\n";
}

my $info='';

if ( $page eq 'backupControl' ) {
  handleControlPage();
} else {
  genControlPage( $info );
}

}

sub handleControlPage {

  my $services = $q->param( 'services' );
  # Check to turn off services
  if ( $services eq 'on' ) {
    # Run the service start script
    if (Cobalt::Util::lock_services(2)) {
      system("/usr/local/sbin/start_services.sh");
      Cobalt::Util::lock_services(0); 
    }
  } else {
    # Run the service stop script
    system("/usr/local/sbin/stop_services.sh");
    Cobalt::Util::lock_services(1);
  }

  my $lock = $q->param( 'uilock' );
  # Check to turn off services
  if ( $lock eq 'on' ) {
    # Lock the UI 
    Cobalt::Util::lock_ui(1);
  } else {
    # Unlock the UI 
    Cobalt::Util::lock_ui(0);
  }

  genControlPage();

}

sub genControlPage {
my ($uilocked,$uiunlocked,$servelocked,$serveunlocked);
# Read in the template
open( TEMPLATE, "$Template_dir/backupControl.tmpl" )
    || die "Cannot read $Template_dir/info.tmpl: $!\n";

    my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
    my $charset = $locale->getProperty("http_Charset");
    my $charsetText;
    if ($charset) {
	$charsetText = "; charset=$charset";
    }
    print "Content-type:  text/html$charsetText\nCache-Control: no-cache\n\n";
    undef($charset, $charsetText);


  if (Cobalt::Util::lock_ui(2)) {
    $uilocked = "CHECKED";
  } else {
    $uilocked = "";
  }

  if (!Cobalt::Util::lock_services(2)) {
    $servelocked = "CHECKED";
  } else {
    $servelocked = "";
  }


while ( <TEMPLATE> ) {
    s/\[USERERROR\]/$info/;
    s/\[BACKUPCONTROLURL\]/$backupControlURL/;
    s/\[LOCKCHECKED\]/$uilocked/g;
    s/\[SERVEONCHECKED\]/$servelocked/g;
    s/\[FONTH\]/$header_style/g;
    s/\[FONTT\]/$table_style/g;
    s/\[FONTB\]/$button_style/g;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/ge;

    print;
}

close TEMPLATE;

}
1;
