#!/usr/bin/perl
#
# Copyright 1998-2000, Cobalt Networks, Inc
# All rights reserved

package Cobalt::UI::bwAdd;

use Cobalt::Meta;
use Cobalt::BandWidth;
use Cobalt::Util;
use Cobalt::User;

sub main {

$URL_add  = "/cgi-bin/.cobalt/turbo_ui/dispatch/bwAdd";
$URL_list = "/cgi-bin/.cobalt/turbo_ui/dispatch/bwList";

my $locale   = Cobalt::Locale->getByHTTPHeader($ENV{ HTTP_ACCEPT_LANGUAGE });
if ($locale) { $ENV{ LANGUAGE }=$locale->get_locale();
 $button_style=$locale->getProperty("buttonStyle");
 $header_style=$locale->getProperty("headerStyle");
 $table_style=$locale->getProperty("tableStyle");
 }

my $forbiddenURL="/.cobalt/error/forbidden.html";
my $user = $ENV{REMOTE_USER};
unless (user_authok($user, "admin")) {
    print "location: $forbiddenURL\n\n";
    die "Unauthoried access by $user, not an admin.\n";
}

$query = shift;
$query->import_names('Q');

$spacer       = '<FONT COLOR="#ffffff">&nbsp;</FONT>';
$help_ipaddr  = MSG_get_ui("bw_help_ipaddr");
$help_bwlimit = MSG_get_ui("bw_help_bwlimit");
$help_invalid = MSG_get_ui("bw_help_invalid");
$str_nofreeip = MSG_get_ui("bw_help_nofreeip");
$str_bwlimit  = MSG_get_ui("bw_bwlimit");
$str_ipaddr   = MSG_get_ui("ipAddr");
$str_bwAdd    = MSG_get_ui("bw_add");
$str_saving   = MSG_get_ui("saving");
$str_save     = MSG_get_ui("saveChanges");
$str_cancel   = MSG_get_ui("cancel");
$str_help     = MSG_get_ui("help");

if ($Q::page eq 'bwadd')
{
    $ipaddr = $Q::ipaddr;
    $limit  = $Q::bwlimit;
    $ret    = &Cobalt::BandWidth::bw_setip(bwlimit => $limit, ip => $ipaddr);

    if ($ret =~ /^2/) { print "Location: ${URL_list}\n\n" }
    else              {	print "Location: ${URL_add}\?info=", substr($ret,4), "\n\n" }
    return 1;
}

$meta = new Cobalt::Meta(type => "vsite");
@iplist = $meta->SQL(qq[ SELECT DISTINCT ipaddr FROM vsite WHERE name != 'default' ]);
%bwip = map { $_ => 1; } $meta->SQL(qq[ SELECT name FROM bw ]);
foreach (@iplist) {
    next unless (/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/);
    unless (exists($bwip{ $_ })) {
	$ipaddrList .= "<OPTION>$_\n";
    }
}
unless ($ipaddrList) {
    print "Location: ${URL_list}\?info=${str_nofreeip}\n\n";
}

$javascript = <<END;
top.showInfo( '$Q::info', 0, 'error' );

var help_ipaddr='$help_ipaddr';
var help_bwlimit='$help_bwlimit';
var help_invalid='$help_invalid';

function trySubmit() {
    var f=document.forms[ 0 ];
    if( f.bwlimit.value < 10 || f.bwlimit.value.length==0 ) {
	top.showInfo( help_invalid );
    }
    else {
	top.showInfo( '${str_saving}', 0, 'wait' );
	return true;
    }
    return false;
}
END

my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
my $charset = $locale->getProperty("http_Charset");
my $charsetText;
if ($charset) {
    $charsetText = "; charset=$charset";
}

print $query->header(-type => 'text/html' . $charsetText, -expires => '-1d');
undef($charset, $charsetText);

print '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">';
print $query->start_html(-title => $str_bwAdd, -BGCOLOR => "#ffffff", -script => $javascript);

print <<END;

<CENTER>
<FORM ACTION="${URL_add}" METHOD="POST" ENCTYPE="application/x-www-form-urlencoded" onSubmit="return trySubmit();">
<TABLE BORDER="1" CELLSPACING="0">
  <TR>
    <TD COLSPAN="3" BGCOLOR="#000099" ALIGN="CENTER"><FONT STYLE=$header_style>${str_bwAdd}</FONT></TD>
  </TR>
  <TR>
    <TD WIDTH="26"><CENTER><A HREF="javascript: top.showInfo( help_ipaddr );" onMouseOver="status='${str_help}'; top.showInfo( help_ipaddr ); return true;"><IMG SRC="/.cobalt/images/smallest_help_but" BORDER="0" ALIGN="BOTTOM"></A></CENTER></TD>
    <TD WIDTH="130" ALIGN="LEFT" VALIGN="MIDDLE" NOWRAP><FONT STYLE=$table_style>${spacer} ${str_ipaddr}</FONT></TD>
    <TD WIDTH="150" ALIGN="LEFT" VALIGN="MIDDLE" NOWRAP><SELECT NAME="ipaddr">${ipaddrList}</SELECT>
    </TD>
  </TR>
  <TR>
    <TD WIDTH="26"><CENTER><A HREF="javascript: top.showInfo( help_bwlimit );" onMouseOver="status='${str_help}'; top.showInfo( help_bwlimit ); return true;"><IMG SRC="/.cobalt/images/smallest_help_but" BORDER="0" ALIGN="BOTTOM"></A></CENTER></TD>
    <TD WIDTH="130" ALIGN="LEFT" VALIGN="MIDDLE" NOWRAP><FONT STYLE=$table_style>${spacer} ${str_bwlimit}</FONT></TD>
    <TD WIDTH="150" ALIGN="LEFT" VALIGN="MIDDLE" NOWRAP><INPUT TYPE="TEXT" NAME="bwlimit" MAXLENGTH="10" SIZE="10"></TD>
  </TR>
</TABLE>
<BR>


<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" >
<TR>

<TD>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0"><TR>
  <TD><A HREF="javascript: if ( trySubmit() ) document.forms[ 0 ].submit();" onMouseOver="status='$str_save'; return true;"><IMG SRC="/libImage/buttonLeftDot.gif" BORDER=0></A></TD>

  <TD NOWRAP STYLE="$button_style" ><A HREF="javascript: if ( trySubmit() ) document.forms[ 0 ].submit();" onMouseOver="status='$str_save'; return true;"><FONT STYLE="$button_style">${str_save}</FONT></A></TD>

  <TD><A HREF="javascript: if ( trySubmit() ) document.forms[ 0 ].submit();" onMouseOver="status='$str_save'; return true;"><IMG SRC="/libImage/buttonRight.gif" BORDER=0></A></TD>

</TR></TABLE></TD>
<TD><IMG BORDER="0" SRC="/libImage/spaceHolder" WIDTH="5"></TD>
<TD>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0"><TR>
  <TD><A HREF="${URL_list}" onMouseOver="status='${str_cancel}'; return true;"><IMG SRC="/libImage/buttonLeftDot.gif" BORDER=0></A></TD>

  <TD NOWRAP STYLE="$button_style" ><A HREF="${URL_list}" onMouseOver="status='${str_cancel}'; return true;"><FONT STYLE="$button_style">${str_cancel}</FONT></A></TD>

  <TD><A HREF="${URL_list}" onMouseOver="status='${str_cancel}'; return true;"><IMG SRC="/libImage/buttonRight.gif" BORDER=0></A></TD>

</TR></TABLE></TD>
</TABLE>

<INPUT TYPE="HIDDEN" NAME="page" SIZE="-1" VALUE="bwadd">
</FORM>
</CENTER>
END

print $query->end_html;

undef ($Q, $query, @iplist, $ipaddrList);
}
1;
