#!/usr/bin/perl
#
# Copyright 1999-2000, Cobalt Networks, Inc
# All rights reserved

package Cobalt::UI::bwList;

use Cobalt::Meta::vsite;
use Cobalt::Util;
use Cobalt::User;
use Cobalt::Locale;

sub main {

$URL     = "/cgi-bin/.cobalt/turbo_ui/dispatch/bwList";
$URL_add = "/cgi-bin/.cobalt/turbo_ui/dispatch/bwAdd";
$URL_del = "/cgi-bin/.cobalt/turbo_ui/dispatch/bwDel";
$URL_mod = "/cgi-bin/.cobalt/turbo_ui/dispatch/bwMod";

my $forbiddenURL="/.cobalt/error/forbidden.html";
my $user = $ENV{REMOTE_USER};
unless (user_authok($user, "admin")) {
    print "location: $forbiddenURL\n\n";
    die "Unauthoried access by $user, not an admin.\n";
}

$query = shift;
$query->import_names('Q');
my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale();
 $button_style=$locale->getProperty("buttonStyle");
 $header_style=$locale->getProperty("headerStyle");
 $table_style=$locale->getProperty("tableStyle");

 }

$help_add     = MSG_get_ui("bw_add");
$help_del     = MSG_get_ui("bw_del");
$help_mod     = MSG_get_ui("bw_mod");
$help_fqdn    = MSG_get_ui("bw_help_vsite");
$help_ipaddr  = MSG_get_ui("bw_help_ipaddr");
$help_bwlimit = MSG_get_ui("bw_help_limit");
$help_action  = MSG_get_ui("bw_help_action");
$help_confirm = MSG_get_ui("bw_help_confirm");
$str_bw_none  = MSG_get_ui("bw_none");
$str_bwList   = MSG_get_ui("bw_list");
$str_ipaddr   = MSG_get_ui("ipAddr");
$str_fqdn     = MSG_get_ui("virtualSites");
$str_help     = MSG_get_ui("help");
$str_saving   = MSG_get_ui("savingWait");
$str_kbps     = MSG_get_ui("kbps");
$str_add     = MSG_get_ui("bwaddbut");

$spacer       = '<FONT COLOR="#ffffff">&nbsp;</FONT>';
$noIcon       = '<IMG SRC="/.cobalt/images/blank" BORDER="0">';
$helpIcon     = '<IMG SRC="/.cobalt/images/smallest_help_but" BORDER="0" ALIGN="BOTTOM">';

$javascript = <<END;
top.showInfo( '$Q::info', 0, 'error' );

var help_fqdn='${help_fqdn}';
var help_ipaddr='${help_ipaddr}';
var help_bwlimit='${help_bwlimit}';
var help_action='${help_action}';

function bwDel( ipaddr ) {
  if( confirm( '$help_confirm' ) ) {
    top.showInfo( '${str_saving}', 0, 'wait' );
    location="${URL_del}\?ipaddr="+escape( ipaddr );
  }
}
END

$meta   = new Cobalt::Meta(type => "bw");
@limits = $meta->SQL("SELECT name, bwlimit FROM bw WHERE name != 'default'");

my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
my $charset = $locale->getProperty("http_Charset");
my $charsetText;
if ($charset) {
    $charsetText = "; charset=$charset";
}

print $query->header(-type => 'text/html' . $charsetText, -expires => '-1d');
undef($charset, $charsetText);

print '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">';
print $query->start_html(-title => $str_bwList, -BGCOLOR => "#ffffff", -script => $javascript);

print <<END;
<CENTER>
<BR>
<TABLE BORDER="1" CELLSPACING="0" WIDTH="500">
<TR>
  <TD COLSPAN="4" BGCOLOR="#000099" ALIGN="CENTER"><FONT STYLE="${header_style}">${str_bwList}</FONT></B></TD>
</TR>
END

unless (scalar(@limits)) {
    print "<TR><TD COLSPAN=4 ALIGN=LEFT VALIGN=MIDDLE>${spacer}<FONT STYLE=${table_style}>${str_bw_none}</FONT></TD></TR>\n";
}
else {

    print <<END;
<TR>
  <TD WIDTH="125" ALIGN="LEFT" VALIGN="MIDDLE" NOWRAP>${spacer}<A HREF="javascript: top.showInfo( help_ipaddr );" onMouseOver="status='${str_help}'; top.showInfo( help_ipaddr ); return true;">${helpIcon}${spacer}</A><FONT STYLE=$table_style>${str_ipaddr}</FONT></TD>
  <TD WIDTH="75" ALIGN="LEFT" VALIGN="MIDDLE" NOWRAP>${spacer}<A HREF="javascript: top.showInfo( help_bwlimit );" onMouseOver="status='${str_help}'; top.showInfo( help_bwlimit ); return true;">${helpIcon}${spacer}</A><FONT STYLE=$table_style>${str_kbps}</FONT></TD>
  <TD WIDTH="250" ALIGN="CENTER" VALIGN="MIDDLE"><A HREF="javascript: top.showInfo( help_fqdn );" onMouseOver="status='${str_help}'; top.showInfo( help_fqdn ); return true;">${helpIcon}${spacer}</A><FONT STYLE=$table_style>${str_fqdn}</FONT></TD>
  <TD WIDTH="50" ALIGN="CENTER" VALIGN="MIDDLE" NOWRAP><A HREF="javascript: top.showInfo( help_action );" onMouseOver="status='${str_help}'; top.showInfo( help_action ); return true;">${helpIcon}</A></TD>
</TR>
END

}

foreach (@limits)
{
    $bwlimit  = $_->get(bwlimit);
    $ipaddr   = $_->get(name);

    $X_mod    = MSG_get_ui("bw_mod_X", $ipaddr);
    $X_del    = MSG_get_ui("bw_del_X", $ipaddr);

    $site     = new Cobalt::Meta::vsite;
    $siteList = join("<br>${spacer}", $site->SQL("SELECT fqdn FROM vsite WHERE ipaddr = '$ipaddr' AND name != 'default'"));

    print <<END;
<TR VALIGN="MIDDLE">
  <TD ALIGN="LEFT" VALIGN="MIDDLE" NOWRAP>${spacer}${ipaddr}</TD>
  <TD ALIGN="LEFT" VALIGN="MIDDLE" NOWRAP>${spacer}${bwlimit}</TD>
  <TD ALIGN="CENTER" VALIGN="MIDDLE">${siteList}</TD>
  <TD ALIGN="LEFT" VALIGN="MIDDLE" NOWRAP>${spacer}<A HREF="${URL_mod}\?ipaddr=${ipaddr}" onMouseOver="status='${X_mod}'; return true;"><IMG SRC="/libImage/modify" ALT="${X_mod}" BORDER="0"></A>${spacer}<A HREF="javascript: bwDel( '${ipaddr}' );" onMouseOver="status='${X_del}'; return true;"><IMG SRC="/libImage/remove" ALT="${X_del}" BORDER="0"></A></TD>
</TR>
END

}

print <<END;
</TABLE>
<BR>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0"><TR>
  <TD><A HREF="${URL_add}" onMouseOver="status='${help_add}'; return true;"><IMG SRC="/libImage/buttonLeftDot.gif" BORDER=0></A></TD>

  <TD NOWRAP STYLE="${button_style}" ><A HREF="${URL_add}" onMouseOver="status='${help_add}'; return true;"><FONT STYLE="${button_style}">$str_add</FONT></A></TD>

  <TD><A HREF="${URL_add}" onMouseOver="status='${help_add}'; return true;"><IMG SRC="/libImage/buttonRight.gif" BORDER=0></A></TD>

</TR></TABLE>

END

print $query->end_html;

}

1;
