#!/usr/bin/perl

# Sendmail Control
# Copyright 1998 Cobalt Networks
# Jun 1998, Sept 1999 Will DeHaan <will@cobaltnet.com>
# 7/4/1999, Kevin K.M. Chiu kevin@cobaltnet.com (internationalization)

package Cobalt::UI::emailparam;

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::Services;
use Cobalt::Netutil;
use Cobalt::Email;
use Cobalt::Network;
use Cobalt::User;

use Locale::gettext;

# Look at all these stupid globals... 
my($q, $locale, $iam, $WEB, $MAXEMAIL, $OLDMAXEMAIL, $DS, $OLDDS, @RELAYUSER, @OLDRELAYUSER, @RELAYSERVER, @OLDRELAYSERVER, @CW, @OLDCW, @CWSAVE, @SPAM, @OLDSPAM, $POPRELAY, $OLDPOPRELAY, $header_style, $table_style, $button_style);

my $Debug ;
my($makemap); 
my($html_ERROR);

my $servicesScriptURL='/cgi-bin/.cobalt/turbo_ui/dispatch/services';

#
#
# Begin main
sub main {

my $forbiddenURL="/.cobalt/error/forbidden.html";
my $user = $ENV{REMOTE_USER};
unless (user_authok($user, "admin")) {
    print "location: $forbiddenURL\n\n";
    die "Unauthorized access by $user, not an admin.\n";
}

$locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale();
$button_style=$locale->getProperty("buttonStyle");
$header_style=$locale->getProperty("headerStyle");
$table_style=$locale->getProperty("tableStyle");
 }

$q=shift;
# Make sure there isn't any cruft in this variable
undef $html_ERROR;

$Debug = (-e "/etc/DEBUG") ? 1 : 0;
$makemap = "$MakeMap_cmd hash $MailDenyFile.db < $MailDenyFile";
$iam='emailparam';

# Parsin'
$WEB = $q -> param('WEBUSAGE');
$MAXEMAIL = $q -> param('MAXEMAIL');
$OLDMAXEMAIL = $q -> param('OLDMAXEMAIL');
$DS = $q -> param('DS');
$POPRELAY = $q -> param('POPRELAY');
$OLDPOPRELAY = $q -> param('OLDPOPRELAY');
$OLDDS = $q -> param('OLDDS');
@RELAYUSER = &enList( $q -> param('RELAYUSER') );
@OLDRELAYUSER = &enList( $q -> param('OLDRELAYUSER') );
@RELAYSERVER = &enList( $q -> param('RELAYSERVER') );
@OLDRELAYSERVER = &enList( $q -> param('OLDRELAYSERVER') );
@CW = &enList( $q -> param('CW') );
@OLDCW = &enList( $q -> param('OLDCW') );
@CWSAVE = &enList( $q -> param('CWSAVE') );
@SPAM = &enList( $q -> param('SPAM') );
@OLDSPAM = &enList( $q -> param('OLDSPAM') );

$Debug = (-e "/etc/DEBUG") ? 1 : 0;
$makemap = "$MakeMap_cmd hash $MailDenyFile.db < $MailDenyFile";

$servicesScriptURL='/cgi-bin/.cobalt/turbo_ui/dispatch/services';

if ($WEB) 
{
  $html_ERROR = &test_dataset; # Checks ALL new data
  $html_ERROR = &update_all unless ($html_ERROR);

  if( $html_ERROR ) {
    &fetch_data;
    &templatize('EmailParam');
  }
  else { print "location: $servicesScriptURL\n\n" }
}
else {
  &fetch_data;
  &templatize('EmailParam');
}

 undef( $html_ERROR, $makemap );
 undef ($q, $locale, $WEB, $MAXEMAIL, $OLDPOPRELAY, $POPRELAY, $OLDMAXEMAIL, $DS, $OLDDS, @RELAYUSER, @OLDRELAYUSER, @RELAYSERVER, @OLDRELAYSERVER, @CW, @OLDCW, @CWSAVE, @SPAM, @OLDSPAM);

}
# Fin main
#
#

sub fetch_data
# Defines the all-caps globals
{
  # In megabytes..
  $MAXEMAIL = $OLDMAXEMAIL = int( mail_get_max_document()/1048576 );
  if( $MAXEMAIL==0 ) { $MAXEMAIL=''; }
 
  $DS = $OLDDS = mail_get_smart_relay();

  $POPRELAY = $OLDPOPRELAY = mail_get_poprelay();
 
  @OLDRELAYUSER = @RELAYUSER = mail_get_relay();
  
  if ($Features{'SERVER_RELAY'}) {
    open(SRV,"$MailRelayList");
    while(<SRV>) { chop; push(@RELAYUSER,$_); }
    close(SRV);
    @OLDRELAYSERVER = @RELAYSERVER;
  }
  
  @CW = mail_list_cw();
  my %email_routes = Cobalt::Email::mail_virtuser_list_route();
  my ($route);
  foreach $route (keys %email_routes) {
      @CW = grep { ! /^$route$/ } @CW;
      push @CWSAVE, $route;
  }
  @OLDCW = @CW;
  
  @OLDSPAM = @SPAM = mail_get_deny();
  
}

sub test_dataset
# Uses all-caps globals
# builds error summary as all data is checked
{
  my($html_ERROR,$set,@testset,$elmnt,$ip_frag,$de_elmnt,$frag_cnt);

  # relayuser, relayserver need network and/or hosts
  push(@testset,@RELAYUSER);
  push(@testset,@RELAYSERVER);
  
  foreach $elmnt (@testset) {
    if( !Cobalt::Netutil::netutil_test_netaddr( $elmnt, 1 ) ) {
      $html_ERROR .= "".eval("\"".Locale::gettext::dgettext("ui", "notValidNetworkAddress")."\"")."<BR>";
    }
  }
  
  # sendmail.cw
  foreach $elmnt (@CW) {
    if( !Cobalt::Netutil::netutil_test_netaddr( $elmnt ) ) {
      $html_ERROR .= "".eval("\"".Locale::gettext::dgettext("ui", "notValidNetworkAddress")."\"")."<BR>";
    }
  }
  
  # Spammery
  foreach $elmnt (@SPAM) {
    if ($elmnt =~ /\@/) { # We think it's an email address
      if( !Cobalt::Netutil::netutil_test_emailaddr( $elmnt ) ) {
      $html_ERROR .= "".eval("\"".Locale::gettext::dgettext("ui", "notValidNetworkAddress")."\"")."<BR>";
      }
    }
    elsif( !Cobalt::Netutil::netutil_test_domainname( $elmnt ) || Cobalt::Netutil::netutil_test_ipaddr( $elmnt)) {
      $html_ERROR .= "".eval("\"".Locale::gettext::dgettext("ui", "onlyEmailsOrHosts")."\"")."<BR>";
    }
  }
  
  # Max Message
  if( $MAXEMAIL ne '' ) {
    if( $MAXEMAIL!~/^\d*$/ || $MAXEMAIL==0 ) {
      $html_ERROR .= "".eval("\"".Locale::gettext::dgettext("ui", "maxDocumentSize")."\"")."<BR>";
    }
  }
  
  # Relay host 
  if( $DS ne '' ) {
    unless( Cobalt::Netutil::netutil_test_domainname($DS) ) {
      $html_ERROR .= "".eval("\"".Locale::gettext::dgettext("ui", "invalidSmartRelay")."\"")."<BR>";
    }
  }
  
  return($html_ERROR);
}


sub update_all
{
  my $ret;
  
  # Max document size
  if ($MAXEMAIL eq '') {
      $MAXEMAIL=0;
  }
  if ($MAXEMAIL != $OLDMAXEMAIL) {
      $ret = mail_set_max_document(int($MAXEMAIL)*1048576);
      $OLDMAXEMAIL = $MAXEMAIL;  # reset diff
      return($1) if ($ret =~ /^4\d\d\d(.*)/);
  }
  if ($POPRELAY != $OLDPOPRELAY) {
      $ret = mail_set_poprelay($POPRELAY);
      $OLDPOPRELAY = $POPRELAY;  # reset diff
      return($1) if ($ret =~ /^4\d\d\d(.*)/);
  }
  # "Smart" relay 
  if ($DS ne $OLDDS) {
      $ret = mail_set_smart_relay($DS);
      $OLDDS = $DS; 
      return($1) if ($ret =~ /^4\d\d\d(.*)/);
  }
  
  # SPAM
  if (join(' ',@SPAM) ne join(' ',@OLDSPAM)) {
      $ret = mail_set_deny(@SPAM);
      @OLDSPAM = @SPAM;
      return($1) if ($ret !~ /^2/);
  }
  
  # User relay 
  if (join(' ',@RELAYUSER) ne join(' ',@OLDRELAYUSER)) {
      $ret = mail_del_relay(@OLDRELAYUSER);
      return($1) if ($ret !~ /^2/);
      $ret = mail_add_relay(@RELAYUSER);
      return($1) if ($ret !~ /^2/);
      @OLDRELAYUSER = @RELAYUSER;
  }
  
  # Server relay
  if (join(' ',@RELAYSERVER) ne join(' ',@OLDRELAYSERVER)) {
      &array2flat($MailRelayList,@RELAYSERVER);
      @OLDRELAYSERVER = @RELAYSERVER;
  }
  
  # sendmail.cw
  if (join(' ',@CW) ne join(' ',@OLDCW)) {
      push (@CW, @CWSAVE);
      my %diff = map { $_, 1 } @CW;
      @CW = keys %diff;
      &array2flat($Sendmail_cw,@CW);
      @OLDCW = @CW;
  }
  
  Cobalt::Email::mail_sendmail_hup();
  
  return 0;
}


sub enList
# Takes a messy user input string and filters/sorts it into an array
{
	my($dataset) = $_[0];
	$dataset =~ s/[\n\r\t\,\;\:]/ /og;
	$dataset =~ s/^\s+//og;
	return ( sort( split(/\s+/,$dataset) ) );
}


sub templatize {
	my($template) = $_[0];
	$template = "$Template_dir/emailparam.tmpl"; 

	if ($html_ERROR =~ /\w/) { # Error pre-formatting
	    # error is returned in a table to support multi-line errors
	    $html_ERROR =~ s/[\n\r]//g;
	}

	# html likes strings, boring
	my($RELAYUSER) = join("\n",sort(@RELAYUSER));
	my($OLDRELAYUSER) = join("\n",@OLDRELAYUSER);
	my($RELAYSERVER) = join("\n",@RELAYSERVER);
	my($OLDRELAYSERVER) = join("\n",@OLDRELAYSERVER);
	my($CW) = join("\n",sort(@CW));
	my($OLDCW) = join("\n",@OLDCW);
	my($CWSAVE) = join("\n",@CWSAVE);
	my($SPAM) = join("\n",sort(@SPAM));
	my($OLDSPAM) = join("\n",@OLDSPAM);
	my $POPRELAYCHECKED = ' CHECKED' if ($POPRELAY);

	my($domain) = (Cobalt::Network::net_get_dnsclient())[0];

    my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
    my $charset = $locale->getProperty("http_Charset");
    my $charsetText;
    if ($charset) {
	$charsetText = "; charset=$charset";
    }
    print "Content-type:  text/html$charsetText\nCache-Control: no-cache\n\n";
    undef($charset, $charsetText);

#	print "$html_ERROR";
	if (-e "$template") {
		open(TMPL,"$template");
		while(<TMPL>) {
			s/\[IAM\]/$iam/g;
			s/\[MAXEMAIL\]/$MAXEMAIL/g;
			s/\[OLDMAXEMAIL\]/$OLDMAXEMAIL/g;
			s/\[DS\]/$DS/g;
			s/\[POPRELAYCHECKED\]/$POPRELAYCHECKED/g;
			s/\[OLDPOPRELAY\]/$OLDPOPRELAY/g;
			s/\[OLDDS\]/$OLDDS/g;
			s/\[RELAYUSER\]/$RELAYUSER/g;
			s/\[OLDRELAYUSER\]/$OLDRELAYUSER/g;
			s/\[RELAYSERVER\]/$RELAYSERVER/g;
			s/\[OLDRELAYSERVER\]/$OLDRELAYSERVER/g;
			s/\[CW\]/$CW/g;
			s/\[OLDCW\]/$OLDCW/g;
			s/\[CWSAVE\]/$CWSAVE/g;
			s/\[SPAM\]/$SPAM/;
			s/\[OLDSPAM\]/$OLDSPAM/;
			s/\[DOMAIN\]/$domain/;
			s/\[SHOWINFO\]/$html_ERROR/;
                        s/\[FONTH\]/$header_style/g;
                        s/\[FONTT\]/$table_style/g;
                        s/\[FONTB\]/$button_style/g;


			s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/ge;

			print;
		}
	} else {
		# Ack! No template
	  print "Ack! No template";
	}
}


sub array2flat {
        my($file,@data) = @_;
	my($data);

        open(OUTFL,"> $file") || die "Can't write file: $!";
        foreach $data (@data) {
                print OUTFL "$data\n" if ($data =~ /\S/);
        }
        close(OUTFL);
}

	
# No return value
sub dump_relay {
        my(@list) = @_;
        # No need to filter/test data at this point

        my($net,@netlist,%nets);
        my(@domlist,%domains);

        foreach $net (@list) {
                if ($net =~ /[a-zA-Z]/) {
                        # Domain
                        push(@domlist,$net) unless ($domains{"$net"});
                        $domains{"$net"} = 1;
                } else {
                        # IP net or nul
			push(@netlist,$net) unless (($net !~ /\w/) || $nets{"$net"});
                        $nets{"$net"} = 1;
                }
        }

	&array2flat($MailIPList,@netlist);
	&array2flat($MailNameList,@domlist);
}
1;
