#!/usr/bin/perl

# author: Patrick Bose 
#         Cobalt Networks
# version: 1.0
#
# Copyright 2000, Cobalt Networks, Inc
# All rights reserved

package Cobalt::UI::fanMonitor;

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::Meta;
use Cobalt::User;
use Cobalt::swatch;

use Locale::gettext;

#
# global variables
#
my ( $q, $locale, $button_style, $header_style, $table_style);
my $alertScriptURL='/cgi-bin/.cobalt/turbo_ui/dispatch/alert';

sub main {

$q=shift;

$locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); 
                $button_style=$locale->getProperty("buttonStyle");
                $header_style=$locale->getProperty("headerStyle");
                $table_style=$locale->getProperty("tableStyle"); }

my $forbiddenURL="/.cobalt/error/forbidden.html";
my $user = $ENV{REMOTE_USER};
unless (user_authok($user, "admin")) {
    print "location: $forbiddenURL\n\n";
    die "Unauthorized access by $user, not an admin.\n";
}

my ($message, $rpm, $alldefcon, $defcon, $fan, $fan_report, $image);
$fan_report="";

$alldefcon = swatch_get_defcon("fans");
if ($alldefcon) {
	if ( $alldefcon == 1 ) {
		$message = "[str.fan_defcon_okay]";
		$ball = $defcon_images{ 1 };
	} else {
		$message = "[str.fan_defcon_failed]";
		# Pushing yellow to red here... If a fan is slow but
		# not dead, it probably will be dead soon.
		$ball = $defcon_images{ 3 };

		$fan = Cobalt::Meta->create("type" => "fan");

		for ($i=0; $i<6; $i++) {
			$fan->retrieve("fan$i");
			$rpm = int($fan->get("rpm"));
			$defcon = int($fan->get("defcon"));
			if ( $defcon < 2 ) {
				$image = "/.cobalt/images/fanGood.gif";
			} else {
				$image = "/.cobalt/images/fanBad.gif";
			}
			$fan_report .= "<TD ALIGN=\"center\" WIDTH=\"40\"><img src=\"$image\" alt=\"[str.fan_rpm] $rpm\" width=\"40\" height=\"40\"></td>\n";

			if ( 2 == $i )  {
				$fan_report .= "<TD ALIGN=\"center\" WIDTH=\"14\"><img src=\"/.cobalt/images/spacer1.gif\" alt=\"\" width=\"1\" height=\"1\" hspace=\"7\" vspace=\"5\" border=\"0\"></td>";
			}
		}
	}
} else {
	$ball = $defcon_images{ 0 };
	$message = "[str.swatch_body_defcon_0]";
}

my $back;
if ($q->param('alert')) {
	$back="<TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\"><TR>
  			<TD><A HREF=\"$alertScriptURL\" onMouseOver=\"status='[str.back]'; return true;\"><IMG SRC=\"/libImage/buttonLeftDot.gif\" BORDER=0></A></TD>
				<TD NOWRAP STYLE=\"[FONTB]\" ><A HREF=\"$alertScriptURL\" onMouseOver=\"status='[str.back]'; return true;\"><FONT STYLE=\"[FONTB]\">[str.back]</FONT></A></TD>
				<TD><A HREF=\"$alertScriptURL\" onMouseOver=\"status='[str.back]'; return true;\"><IMG SRC=\"/libImage/buttonRight.gif\" BORDER=0></A></TD>
			</TR></TABLE>";
}

# Read in the template
open( TEMPLATE, "$Template_dir/fanMonitor.tmpl" )
    || die "Cannot read $Template_dir/fanMonitor.tmpl: $!\n";

    my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
    my $charset = $locale->getProperty("http_Charset");
    my $charsetText;
    if ($charset) {
	$charsetText = "; charset=$charset";
    }
    print "Content-type:  text/html$charsetText\nCache-Control: no-cache\n\n";
    undef($charset, $charsetText);


while ( <TEMPLATE> ) {
    s/\[FANREPORT\]/$fan_report/;
    s/\[BACK\]/$back/;
    s/\[DEFCON\]/$ball/;
    s/\[MESSAGE\]/$message/;
    s/\[FONTH\]/$header_style/g;
    s/\[FONTT\]/$table_style/g;
    s/\[FONTB\]/$button_style/g;

    if ( $alldefcon > 1 ) {
	s/\[BEGINHIDEBOX\]//o;
	s/\[ENDHIDEBOX\]//o;
    } else {
	s/\[BEGINHIDEBOX\]/<!-- /o;
	s/\[ENDHIDEBOX\]/ --> /o;
    }


    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/ge;

    print;
}

close TEMPLATE;
}
1;
