#!/usr/bin/perl

# author: Kevin K.M. Chiu
# version: 2.0
# date: 07-01-99
#
# Copyright 1998-1999, Cobalt Networks, Inc
# All rights reserved

package Cobalt::UI::mailListDel;

use Cobalt::Product;
use Cobalt::List;
use Cobalt::User;

#use strict;
my ($q,$listName,$group);
my $mailListListScriptURL="/cgi-bin/.cobalt/turbo_ui/dispatch/mailListList";
my $forbiddenURL="/.cobalt/error/forbidden.html";

sub main {

$q=shift;


$listName=$q->param( 'listname' );
$group=$q->param( 'group' );

# force login
my $loginName=$ENV{ REMOTE_USER };
unless (user_authok($loginName, "site-adm", $group)) {
    print "location: $forbiddenURL\n\n";
    die "Unauthorised access by $loginName, not a member of $group.\n";
} 

handleMailListDelPage();

}

#
# event handler for delete mailing list page
#
sub handleMailListDelPage {
    my $err=0;
    my $info;

    # remove mailing list
    my $fqdn = (Cobalt::Vsite::vsite_get_bygroup($group))[1];
    my $ret=list_delete($group, $fqdn, $listName);
    if( $ret!~/^2/ ) {
	$info.=substr( $ret, 4 ).'<BR>';
	$err=1;
    }

    if( $err ) {
        print "location: $mailListListScriptURL?info=$info&group=$group \n\n";
    }
    else {
        print "location: $mailListListScriptURL?group=$group \n\n";
    }
}

1;
