#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 3.0
# date: 8-17-98
#
# Version 2.0 uses Monitor.pm instead of AlertDB.pm
#
# Copyright 1998-1999, Cobalt Networks, Inc
# All rights reserved

package Cobalt::UI::memUsage;

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::Meta;
use Cobalt::Util;
use Cobalt::swatch;
use Cobalt::User;

# global variables
my ( $q, $locale, $page, $button_style, $header_style, $table_style);
my $alertScriptURL='/cgi-bin/.cobalt/turbo_ui/dispatch/alert';

sub main {

$q=shift;

$locale=Cobalt::Locale->getByHTTPHeader($ENV{'HTTP_ACCEPT_LANGUAGE'});
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); 
                $button_style=$locale->getProperty("buttonStyle");
                $header_style=$locale->getProperty("headerStyle");
                $table_style=$locale->getProperty("tableStyle"); }
my ($obj,$defcon,$ball,$msgkey,$message,$info,$back);

my $forbiddenURL="/.cobalt/error/forbidden.html";
my $user = $ENV{REMOTE_USER};
unless (user_authok($user, "admin")) {
    print "location: $forbiddenURL\n\n";
    die "Unauthorized access by $user, not an admin.\n";
}

$obj=Cobalt::Meta->create("type" => "memory");
$obj->retrieve("memory");
$defcon = swatch_get_defcon("memory");
if ($defcon) {
    $message = MSG_get_ui("swatch_memory_body_defcon_$defcon");
    $ball = $defcon_images{$defcon};
    
    my ($total,$free,$used,$percent);
    $total = $obj->get("total");
    $free = $obj->get("free");
    $used = $obj->get("used");
    $percent = $obj->get("percent");
    my $kb = MSG_get_ui("swatch_memory_kb");

    # Report real memory sizes
    my($ram_size, $swap_size);
    open(MEM, "/bin/cat $Mem_info |") || die "Cannot read /proc/meminfo: $!\n";
    while (<MEM>) {
	if(/^MemTotal:\s+(\d+)\s/) {
	    $ram_size = $1;
	} elsif (/^SwapTotal:\s+(\d+)\s/) {
	#     $swap_size = $1;
	}
    }
    close(MEM);
    $swap_size = int (($total-$ram_size)/16384)*16;
    $ram_size = int (($ram_size+16384)/16384)*16;
    # $swap_size = int (($swap_size+16384)/16384)*16;
 
    $info = sprintf "<BR><BR> %s <BR> %s <BR> %s <BR>\n",
		MSG_get_ui("swatch_memory_total", $total, $ram_size, $swap_size),
		MSG_get_ui("swatch_memory_free", $free),
		MSG_get_ui("swatch_memory_used", $used, $percent);

} else {
    $message = MSG_get_ui("swatch_body_defcon_0");
    $ball = $defcon_images{0};
}

if($q->param('alert')) {
	$back="<TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\"><TR>
  			<TD><A HREF=\"$alertScriptURL\" onMouseOver=\"status='[str.back]'; return true;\"><IMG SRC=\"/libImage/buttonLeftDot.gif\" BORDER=0></A></TD>
				<TD NOWRAP STYLE=\"[FONTB]\" ><A HREF=\"$alertScriptURL\" onMouseOver=\"status='[str.back]'; return true;\"><FONT STYLE=\"[FONTB]\">[str.back]</FONT></A></TD>
				<TD><A HREF=\"$alertScriptURL\" onMouseOver=\"status='[str.back]'; return true;\"><IMG SRC=\"/libImage/buttonRight.gif\" BORDER=0></A></TD>
			</TR></TABLE>";
}
    
# Read in the template
open( TEMPLATE, "$Template_dir/memUsage.tmpl" )
    || die "Cannot read $Template_dir/memUsage.tmpl: $!\n";

    my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
    my $charset = $locale->getProperty("http_Charset");
    my $charsetText;
    if ($charset) {
	$charsetText = "; charset=$charset";
    }
    print "Content-type:  text/html$charsetText\nCache-Control: no-cache\n\n";
    undef($charset, $charsetText);


while ( <TEMPLATE> ) {
    s/\[DEFCON\]/$ball/;
    s/\[MESSAGE\]/$message/;
    s/\[INFO\]/$info/;
    s/\[BACK\]/$back/;
    s/\[FONTH\]/$header_style/g;
    s/\[FONTT\]/$table_style/g;
    s/\[FONTB\]/$button_style/g;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/ge;

    print;
}

close TEMPLATE;

}
1;
