#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 3.0
# date: 7-2-98
#
# Version 2.0 uses Monitor.pm instead of AlertDB.pm
#
# Copyright 1998-1999, Cobalt Networks, Inc
# All rights reserved

package Cobalt::UI::networkUsage;

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::Meta;
use Cobalt::Network;
use Cobalt::User;

use Locale::gettext;

#
# global variables
#
my ( $q, $locale, $button_style, $header_style, $table_style);
my $alertScriptURL='/cgi-bin/.cobalt/turbo_ui/dispatch/alert';


sub main {

$q=shift;

$locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); 
                $button_style=$locale->getProperty("buttonStyle");
                $header_style=$locale->getProperty("headerStyle");
                $table_style=$locale->getProperty("tableStyle"); }

my $forbiddenURL="/.cobalt/error/forbidden.html";
my $user = $ENV{REMOTE_USER};
unless (user_authok($user, "admin")) {
    print "location: $forbiddenURL\n\n";
    die "Unauthorized access by $user, not an admin.\n";
}

# read network data
my @if = Cobalt::Network::net_get_interfaces();
undef my %if;
for (@if) { $if{$_} = 1; }
my (%eth0,%eth1);
my @data = ("in_bytes", "out_bytes", "in_packets", "out_packets", "errors", "collisions");

my $oe0 = Cobalt::Meta->create("type" => "network");
$oe0->retrieve("eth0");
my $oe1 = Cobalt::Meta->create("type" => "network");
$oe1->retrieve("eth1");

foreach (@data) {
    $eth0{$_} = int($oe0->get($_));
    $eth1{$_} = int($oe1->get($_));
}

my $back;
if ($q->param('alert')) {
	$back="<TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\"><TR>
  			<TD><A HREF=\"$alertScriptURL\" onMouseOver=\"status='[str.back]'; return true;\"><IMG SRC=\"/libImage/buttonLeftDot.gif\" BORDER=0></A></TD>
				<TD NOWRAP STYLE=\"[FONTB]\" ><A HREF=\"$alertScriptURL\" onMouseOver=\"status='[str.back]'; return true;\"><FONT STYLE=\"[FONTB]\">[str.back]</FONT></A></TD>
				<TD><A HREF=\"$alertScriptURL\" onMouseOver=\"status='[str.back]'; return true;\"><IMG SRC=\"/libImage/buttonRight.gif\" BORDER=0></A></TD>
			</TR></TABLE>";
}

# Read in the template
open( TEMPLATE, "$Template_dir/networkUsage.tmpl" )
    || die "Cannot read $Template_dir/networkUsage.tmpl: $!\n";

    my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
    my $charset = $locale->getProperty("http_Charset");
    my $charsetText;
    if ($charset) {
	$charsetText = "; charset=$charset";
    }
    print "Content-type:  text/html$charsetText\nCache-Control: no-cache\n\n";
    undef($charset, $charsetText);


while ( <TEMPLATE> ) {
    s/\[ETH0_IN_BYTES\]/$eth0{"in_bytes"}/;
    s/\[ETH0_OUT_BYTES\]/$eth0{"out_bytes"}/;
    s/\[ETH0_IN_PACKETS\]/$eth0{"in_packets"}/;
    s/\[ETH0_OUT_PACKETS\]/$eth0{"out_packets"}/;
    s/\[ETH0_ERRORS\]/$eth0{"errors"}/;
    s/\[ETH0_COLLISIONS\]/$eth0{"collisions"}/;

    s/\[ETH1_IN_BYTES\]/$eth1{"in_bytes"}/;
    s/\[ETH1_OUT_BYTES\]/$eth1{"out_bytes"}/;
    s/\[ETH1_IN_PACKETS\]/$eth1{"in_packets"}/;
    s/\[ETH1_OUT_PACKETS\]/$eth1{"out_packets"}/;
    s/\[ETH1_ERRORS\]/$eth1{"errors"}/;
    s/\[ETH1_COLLISIONS\]/$eth1{"collisions"}/;

    s/\[BACK\]/$back/;
    s/\[FONTH\]/$header_style/g;
    s/\[FONTT\]/$table_style/g;
    s/\[FONTB\]/$button_style/g;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/ge;

    if (exists $if{'eth1'}) {
	s/\[BEGINHIDEETH1\]//o;
	s/\[ENDHIDEETH1\]//o;
    } else {
	s/\[BEGINHIDEETH1\]/<!-- /o;
	s/\[ENDHIDEETH1\]/ --> /o;
    }

    print;
}

close TEMPLATE;
}
1;
