#!/usr/bin/perl

# author: Patrick Bose
#       Cobalt Networks
# version: 1.0
# date: 8-24-00
#
# Copyright 1999-2000, Cobalt Networks, Inc
# All rights reserved

package Cobalt::UI::redirect;

use Cobalt::Vsite;
use Cobalt::Locale;

# global variables
my ($q,$goto,$location,$group,$host);

sub main {

	$q=shift;
	$host=$q->param( 'hostname' );
	$goto=$q->param( 'goto' );

	$goto = "&goto=$goto" if ( $goto );

	# blank this out
	$group = "";

	my @vhosts = Cobalt::Vsite::vsite_list();

	my $matches = my $byip = 0;

	foreach $vhost ( @vhosts ) {
		# try by fqdn first
		if ( $$vhost[1] eq $host ) {
			$group = $$vhost[2];
		}

		# now try by ip
		if ($$vhost[0] eq $host)
		{
			$byip = 1;
			$matches++;
			$group = $$vhost[2];
		}
	}

	# if we still don't know the group for certain (probably because a user 
	# went to the ip address instead of the fqdn) try to figure out which group
	# the user belongs to, this actually fudges admin and alteradmin
	# to home if they use an ip that is used by more than one site and go
	# to siteadmin
	if ($matches > 1)
	{
		$group = "";
		$group = Cobalt::Vsite::vsite_getgroup($ENV{REMOTE_USER});

		# default to home if still no group (should only happen for admin)
		$group = "home" unless ($group ne "");

		# set the hostname correctly
		$host = (Cobalt::Vsite::vsite_get_bygroup($group))[1];
	}
	elsif ($byip)
	{
		# get the right hostname if single match for ip
		$host = (Cobalt::Vsite::vsite_get_bygroup($group))[1];
	}

	my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
	my $charset = $locale->getProperty("http_Charset");
	my $charsetText;
	if ($charset) {
	    $charsetText = "; charset=$charset";
	}
	print "Content-type:  text/html$charsetText\nCache-Control: no-cache\n\n";
	undef($charset, $charsetText);
	
	print("<HTML><HEAD><META HTTP-EQUIV=\"expires\" CONTENT=\"0\"></HEAD>\n");
	print("<BODY onLoad=\"isLoaded = true\"><SCRIPT LANGUAGE=\"javascript\">\n");
	print("location.href=\"/nav/cList.php?root=sitemanageRoot&group=$group&hostname=$host$goto\";");
	print("</SCRIPT></BODY></HTML>");

}

1;

