#!/usr/bin/perl

# author: Kevin K.M. Chiu
#         Will DeHaan
#       Cobalt Networks
# version: 2.0
# date: 7-4-99
#
# Copyright (C) 1998-1999, Cobalt Networks, Inc
# All rights reserved

package Cobalt::UI::services;

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::Services;
use Cobalt::swatch;
use Cobalt::User;

use Locale::gettext;

# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# not good for use in setup wizard
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#
# global variables
#
my $scriptURL;
my ( $header_style, $table_style, $button_style, $q, $locale, $page );

sub main {

$q=shift;
$scriptURL='/cgi-bin/.cobalt/turbo_ui/dispatch/services';
$page=$q->param( 'page' );

$locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale();
                $button_style=$locale->getProperty("buttonStyle");
                $header_style=$locale->getProperty("headerStyle");
                $table_style=$locale->getProperty("tableStyle"); }

my $forbiddenURL="/.cobalt/error/forbidden.html";
my $user = $ENV{REMOTE_USER};
unless (user_authok($user, "admin")) {
    print "location: $forbiddenURL\n\n";
    die "Unauthorized access by $user, not an admin.\n";
}

if( $page ne 'servicesmain' ) {
    genPage( \*STDOUT );
}
else {
    my $result='';
    my $err=0;
    my $ret;

    my $currentEmailOn=Cobalt::Services::get_mail_server_on();

    my $emailOn=$q->param( 'email' );
    if( $emailOn=~/on/o ) {
	$ret=Cobalt::Services::set_mail_server_on( 1 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_on("smtp");
	$ret=Cobalt::swatch::swatch_set_service_on("pop3");
	$ret=Cobalt::swatch::swatch_set_service_on("imap");
    } else {
	$ret=Cobalt::Services::set_mail_server_on( 0 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_off("smtp");
	$ret=Cobalt::swatch::swatch_set_service_off("pop3");
	$ret=Cobalt::swatch::swatch_set_service_off("imap");
    }

    my $ftpOn=$q->param( 'ftp' );
    if( $ftpOn=~/on/o ) {
	$ret=Cobalt::Services::set_ftp_server_on( 1 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_on("ftp");
    } else {
	$ret=Cobalt::Services::set_ftp_server_on( 0 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_off("ftp");
    }

    my $sshOn=$q->param( 'ssh' );
    if( $sshOn=~/on/o ) {
	$ret=set_ssh_server_on( 1 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_on("ssh");
    } else {
	$ret=set_ssh_server_on( 0 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_off("ssh");
    }

    my $telnetOn=$q->param( 'telnet' );
    if( $telnetOn=~/on/o ) {
	$ret=set_telnet_server_on( 1 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_on("telnet");
    } else {
	$ret=set_telnet_server_on( 0 );
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
	$ret=Cobalt::swatch::swatch_set_service_off("telnet");
    }

    if( $Features{ 'smb' } ) {
	my $smbOn=$q->param( 'smb' );
	if( $smbOn=~/on/o ) { $ret=Cobalt::Services::set_smb_server_on( 1 ); }
	else { $ret=Cobalt::Services::set_smb_server_on( 0 ); }
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
    }

    if( $Features{ 'aspAdmin' } ) {
        my $aspAdminOn=$q->param( 'aspAdmin' );
        if( $aspAdminOn=~/on/o ) { $ret=Cobalt::Services::set_casp_server_on( 1, 'admin' ); }
        else { $ret=Cobalt::Services::set_casp_server_on( 0, 'admin' ); }
        if( $ret!~/^2/o ) {
            $result.=substr( $ret, 4 ).'<BR>';
            $err=1;
        }
    }

    if( $Features{ 'atalk' } ) {
	my $appleShareOn=$q->param( 'appleshare' );
	if( $appleShareOn=~/on/o ) { $ret=Cobalt::Services::set_atalk_server_on( 1 ); }
	else { $ret=Cobalt::Services::set_atalk_server_on( 0 ); }
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
    }

    if( $Features{ 'snmp' } ) {
	my $snmpOn=$q->param( 'snmp' );
	if( $snmpOn=~/on/o ) {
	    $ret=Cobalt::Services::set_snmp_server_on( 1 );
	    if( $ret!~/^2/o ) {
		$result.=substr( $ret, 4 ).'<BR>';
		$err=1;
	    }
	    $ret=Cobalt::swatch::swatch_set_service_on("snmp");
	} else {
	    $ret=Cobalt::Services::set_snmp_server_on( 0 );
	    if( $ret!~/^2/o ) {
		$result.=substr( $ret, 4 ).'<BR>';
		$err=1;
	    }
	    $ret=Cobalt::swatch::swatch_set_service_off("snmp");
	}
    }

    if( $Features{ 'dns' } ) {
	my $dnsOn=$q->param( 'dns' );
	if( $dnsOn=~/on/o ) {
	    $ret=Cobalt::Services::set_dns_server_on( 1 );
	    if( $ret!~/^2/o ) {
		$result.=substr( $ret, 4 ).'<BR>';
		$err=1;
	    }
	    $ret=Cobalt::swatch::swatch_set_service_on("dns");
	} else {
	    $ret=Cobalt::Services::set_dns_server_on( 0 );
	    if( $ret!~/^2/o ) {
		$result.=substr( $ret, 4 ).'<BR>';
		$err=1;
	    }
	    $ret=Cobalt::swatch::swatch_set_service_off("dns");
	}
    }

    if( $Features{ 'dhcpd' } ) {
	my $dhcpOn=$q->param( 'dhcp' );
	if( $dhcpOn=~/on/o ) { $ret=Cobalt::Services::set_dhcp_server_on( 1 ); }
	else { $ret=Cobalt::Services::set_dhcp_server_on( 0 ); }
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
    }

    if( $Features{ 'ntp' } ) {
	my $ntpOn=$q->param( 'ntp' );
	if( $ntpOn=~/on/o ) { $ret=Cobalt::Services::set_ntp_server_on( 1 ); }
	else { $ret=Cobalt::Services::set_ntp_server_on( 0 ); }
	if( $ret!~/^2/o ) {
	    $result.=substr( $ret, 4 ).'<BR>';
	    $err=1;
	}
    }

    if( !$err ) {
	genPage( \*STDOUT );
    }
    else {
	genPage( \*STDOUT, $result );
    }
}

}

#
# argument 0 is the file handle to generate the page to
# argument 1 is the information shown to user
#
sub genPage {
    my( $handle, $info )=@_;

    my $emailChecked=Cobalt::Services::get_mail_server_on()?'CHECKED':'';
    my $ftpChecked=Cobalt::Services::get_ftp_server_on()?'CHECKED':'';
    my $dnsChecked=( $Features{ 'dns' } && Cobalt::Services::get_dns_server_on() )?'CHECKED':'';
    my $telnetChecked=get_telnet_server_on()?'CHECKED':'';
    my $sshChecked=get_ssh_server_on()?'CHECKED':'';
    my $smbChecked=( $Features{ 'smb' } && Cobalt::Services::get_smb_server_on() )?'CHECKED':'';
    my $appleShareChecked=( $Features{ 'atalk' } && Cobalt::Services::get_atalk_server_on() )?'CHECKED':'';
    my $snmpChecked=( $Features{ 'snmp' } && Cobalt::Services::get_snmp_server_on() )?'CHECKED':'';
    my $dhcpChecked=( $Features{ 'dhcpd' } && Cobalt::Services::get_dhcp_server_on() )?'CHECKED':'';
    my $ntpChecked=( $Features{ 'ntp' } && Cobalt::Services::get_ntp_server_on() )?'CHECKED':'';

    my $aspAdminChecked, aspHostname, aspParameters;
    if( $Features{ 'aspAdmin' } ) {
      $aspParameters = '<FONT COLOR=#FFFFFF>&nbsp;</FON>';
      $aspHostname = $ENV{'HTTP_HOST'};
      $aspHostname =~ s/:81//;
      if( Cobalt::Services::get_casp_server_on('admin') ) {
        $aspAdminChecked = 'CHECKED';
        $aspParameters = "<A HREF=\"http://$aspHostname:5100/\" TARGET=NEW BORDER=0><IMG SRC=\"/libImage/modify\" BORDER=0></A>";
      } else {
        $aspParameters = "<IMG SRC=\"/libImage/modifyGray\" BORDER=0>";
      }  
    }

    if ($info) {
	$info = "'$info', 'error'";
    } else {
	$info = "'', 'status'";
    }

    # Read in the template
    open( TEMPLATE, "$Template_dir/services.tmpl" )
	|| die "Cannot read $Template_dir/services.tmpl: $!\n";

    my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
    my $charset = $locale->getProperty("http_Charset");
    my $charsetText;
    if ($charset) {
	$charsetText = "; charset=$charset";
    }
    print "Content-type:  text/html$charsetText\nCache-Control: no-cache\n\n";
    undef($charset, $charsetText);


    while( <TEMPLATE> ) {
	s/\[EMAILCHECKED\]/$emailChecked/;
	s/\[FTPCHECKED\]/$ftpChecked/;
	s/\[TELNETCHECKED\]/$telnetChecked/;
	s/\[SSHCHECKED\]/$sshChecked/;

	if( $Features{ 'discuss' } ) {
	    s/\[HIDEDISCUSSSTART\]//o;
	    s/\[HIDEDISCUSSEND\]//o;
	}
	else {
	    s/\[HIDEDISCUSSSTART\]/<!-- /o;
	    s/\[HIDEDISCUSSEND\]/ -->/o;
	}

	if( $Features{ 'smb' } ) {
	    s/\[SMBCHECKED\]/$smbChecked/;
	    s/\[HIDESMBSTART\]//o;
	    s/\[HIDESMBEND\]//o;
	}
	else {
	    s/\[HIDESMBSTART\]/<!-- /o;
	    s/\[HIDESMBEND\]/ -->/o;
	}

	if( $Features{ 'atalk' } ) {
	    s/\[APPLESHARECHECKED\]/$appleShareChecked/;
	    s/\[HIDEATALKSTART\]//o;
	    s/\[HIDEATALKEND\]//o;
	}
	else {
	    s/\[HIDEATALKSTART\]/<!-- /o;
	    s/\[HIDEATALKEND\]/ -->/o;
	}

	if( $Features{ 'snmp' } ) {
	    s/\[SNMPCHECKED\]/$snmpChecked/;
	    s/\[HIDESNMPSTART\]//o;
	    s/\[HIDESNMPEND\]//o;
	}
	else {
	    s/\[HIDESNMPSTART\]/<!-- /o;
	    s/\[HIDESNMPEND\]/ -->/o;
	}

	if( $Features{ 'aspAdmin' } ) {
            s/\[ASPCHECKED\]/$aspAdminChecked/;
            s/\[HIDEASPADMINSTART\]//o;
            s/\[HIDEASPADMINEND\]//o;
	    s/\[ASPPARAMETER\]/$aspParameters/;
        }
        else {
            s/\[HIDEASPADMINSTART\]/<!-- /o;
            s/\[HIDEASPADMINEND\]/ -->/o;
        }

	if( $Features{ 'dns' } ) {
	    s/\[DNSCHECKED\]/$dnsChecked/;
	    s/\[HIDEDNSSTART\]//o;
	    s/\[HIDEDNSEND\]//o;
	}
	else {
	    s/\[HIDEDNSSTART\]/<!-- /o;
	    s/\[HIDEDNSEND\]/ -->/o;
	}

	if( $Features{ 'dhcpd' } ) {
	    s/\[DHCPCHECKED\]/$dhcpChecked/;
	    s/\[HIDEDHCPDSTART\]//o;
	    s/\[HIDEDHCPDEND\]//o;
	}
	else {
	    s/\[HIDEDHCPDSTART\]/<!-- /o;
	    s/\[HIDEDHCPDEND\]/ -->/o;
	}

	if( $Features{ 'ntp' } ) {
	    s/\[NTPCHECKED\]/$ntpChecked/;
	    s/\[HIDENTPSTART\]//o;
	    s/\[HIDENTPEND\]//o;
	}
	else {
	    s/\[HIDENTPSTART\]/<!-- /o;
	    s/\[HIDENTPEND\]/ -->/o;
	}

	s/\[USER_INFO\]/$info/;
	s/\[SCRIPTURL\]/$scriptURL/o;
	s/\[FONTH\]/$header_style/g;
	s/\[FONTT\]/$table_style/g;
	s/\[FONTB\]/$button_style/g;

	s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/ge;

	print $handle $_;
    }
    close TEMPLATE;

   undef ($q, $locale, $page, $err, $ret, $result );
}

1;
