#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 2.0
# date: 7-6-99
#
# Copyright (C) 1999-2000, Cobalt Networks, Inc
# All rights reserved

package Cobalt::UI::userUsage;

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::User;

use Locale::gettext;


sub main {

my ($button_style, $header_style, $table_style);
my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); 
                $button_style=$locale->getProperty("buttonStyle");
                $header_style=$locale->getProperty("headerStyle");
                $table_style=$locale->getProperty("tableStyle"); }

my $loginName=$ENV{ REMOTE_USER };

# force login
# if( !$loginName ) { print "location: $scriptURL\n\n"; }

# read total disk space
my $totalFree=0;
open( DF,"$Df_cmd |") || die "Can't execute $Df_cmd: $!\n";
while ( <DF> ) {
    if ( /^\/dev\/.d/o ) {
	# only free space on home is truly free
	if( $_=~/\/home/o ) {
	    my @info=split(/\s+/o);
	    $totalFree+=$info[ 3 ];
	}
    }
}
close DF;


my( $userQuota, $userUsage )=( user_show( $loginName ) )[ 2, 3 ];

# block to MB
$totalFree*=$BytesPerBlock/1048576;
$userQuota*=$BytesPerBlock/1048576;
$userQuota=sprintf("%1.1f", $userQuota);
$userUsage*=$BytesPerBlock/1048576;
$userUsage=sprintf("%.1f", $userUsage);

# Note: disk usage can be larger than quota because it is a soft quota
my $userFree;
if( $userQuota==0 ) {
    $userFree=$totalFree;
}
else {
    $userFree=( $userQuota>$userUsage )?$userQuota-$userUsage:0;
    if( $userFree>$totalFree ) { $userFree=$totalFree; }
}
$userFree=sprintf("%.1f", $userFree);

my $userUsageBar=sprintf("%1.f", $userUsage/( $userFree+$userUsage )*100 );
my $userFreeBar=100-$userUsageBar;

# Note: this is only valid if userUsageBar has a width of 100
my $userUsagePercentage=$userUsageBar;

my $userQuotaField;
if( $userQuota==0 ) {
    $userQuotaField = "<I>".eval("\"".Locale::gettext::dgettext("ui", "unlimited")."\"")."</I>";
    $userFree = "<I>".eval("\"".Locale::gettext::dgettext("ui", "unlimited")."\"")."</I>";
    $userUsagePercentage=0;
} 
else { 
    $userQuotaField = $userQuota; 
}

my $usageBarField='<IMG SRC="/libImage/bar0.jpg" HEIGHT=20 BORDER=0>';
if( $userUsageBar>0 ) { $usageBarField .= "<IMG SRC=\"/libImage/bar1.jpg\" WIDTH=$userUsageBar HEIGHT=20 BORDER=0>"; }
if( $userFreeBar>0 ) {  $usageBarField .= "<IMG SRC=\"/libImage/bar2.jpg\" WIDTH=$userFreeBar HEIGHT=20 BORDER=0>"; }
$usageBarField.="<IMG SRC=\"/libImage/bar3.jpg\" HEIGHT=20 BORDER=0><FONT STYLE=\"[FONTT]\">&nbsp;$userUsagePercentage%</FONT>";

# Read in the template
open( TEMPLATE, "$Template_dir/userUsage.tmpl" )
    || die "Cannot read $Template_dir/userUsage.tmpl: $!\n";

    my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
    my $charset = $locale->getProperty("http_Charset");
    my $charsetText;
    if ($charset) {
	$charsetText = "; charset=$charset";
    }
    print "Content-type:  text/html$charsetText\nCache-Control: no-cache\n\n";
    undef($charset, $charsetText);


while( <TEMPLATE> ) {
    s/\[USERUSAGE\]/$userUsage/;
    s/\[USERFREE\]/$userFree/;
    s/\[USERQUOTA\]/$userQuotaField/;
    s/\[USAGE_BAR\]/$usageBarField/;
    s/\[FONTH\]/$header_style/g;
    s/\[FONTT\]/$table_style/g;
    s/\[FONTB\]/$button_style/g;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/ge;

    print;
}
close TEMPLATE;

}
1;
