#!/usr/bin/perl
#
# Copyright 1998-2000, Cobalt Networks, Inc
# All rights reserved

package Cobalt::UI::userlist;

require Cobalt::Locale;
require Cobalt::User;
require Cobalt::Vsite;
require Cobalt::Util;
use Cobalt::Product;
use Cobalt::Meta;

use Fcntl qw/O_RDONLY O_RDWR O_CREAT/;
use DB_File;
use Locale::gettext;
use Jcode;

# global variables
my ($q, $page, $locale, $group);
my $scriptURL;

sub main {

  $q=shift;
  $page=$q->param(page);
  $group=$q->param(group);
  $mode=$q->param(exportmode);

  $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
  if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale();
                $button_style=$locale->getProperty("buttonStyle");
                $header_style=$locale->getProperty("headerStyle");
                $table_style=$locale->getProperty("tableStyle"); }

  my $forbiddenURL="/.cobalt/error/forbidden.html";
  my $user = $ENV{REMOTE_USER};
  unless (Cobalt::User::user_authok($user, "site-adm", $group)) {
      print "location: $forbiddenURL\n\n";
      die "Unauthorized access by $user, not an admin.\n";
  }

  $scriptURL="/cgi-bin/.cobalt/turbo_ui/dispatch/userlist\?group=$group";
  $scriptStatusURL="/cgi-bin/.cobalt/turbo_ui/dispatch/userBulkAdd\?group=$group&page=bulkstatus";

    my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
    my $exportCharset = $locale->getProperty("userExport_Charset");
    my $exportCharsetText;
    if ($exportCharset) {
	$exportCharsetText = "; charset=$exportCharset";
    }
    print "Content-type:  application/octet-stream\nContent-Disposition: attachment; filename=userlist.txt\nCache-Control: no-cache\n\n";

    # query the database with acquired settings
    my @keys = ( "vsite", "name", "fullname", 
                 "aliases", "altname" );

    # not all languages handle sorting the 'fullname' field
    # so there is a field called 'altname' that can be used
    my $altname = $locale->getProperty("fullname_sort");
    if ("$altname") {
        push @keys, "name($altname) as alt";
    }
  
    my @where = ();
    unshift @where, ("vsite", "=", $group);

    @users = Cobalt::Meta::query("type"  => "users",
                                 "keys"  => \@keys,
                                 "where" => \@where);

    my $sort_name = '';
    foreach (@users) {
        $name = $_->get("name");
	if ($exportCharset eq "x-sjis") {
	    $name = Jcode->new($name, "euc")->sjis;
	}
        $username = $name;

        $aliases = $_->get("aliases");
        $aliases =~ s/\s+/ /g;
	if ($exportCharset eq "x-sjis") {
	    $aliases = Jcode->new($aliases, "euc")->sjis;
	}
        $fullname = $_->get("fullname");
	if ($exportCharset eq "x-sjis") {
	    $fullname = Jcode->new($fullname, "euc")->sjis;
	}
	$sort_name = $_->get("altname");
	if ($exportCharset eq "x-sjis") {
	    $sort_name = Jcode->new($sort_name, "euc")->sjis;
	}
          if ( $mode eq "0" ) {
            $passwd = $username; 
          } else {
            srand;
            my ($web_pw, $charcode);
            while(length($web_pw) < 8)
            {   
              $charcode = int(65+rand(58));
              next if ((90 < $charcode) && ($charcode < 97));
              $web_pw .= pack("c",$charcode);
            }
            $passwd = $web_pw; 
          }
          print "$username\t$fullname\t$passwd\t$aliases\t$sort_name\r\n";
    }

}
undef($exportCharset, $exportCharsetText);

1;
