#!/usr/bin/perl
#
# Cobalt Personal Backup, Edition IV
# Will DeHaan, will@cobalt.com/cobalt@guck.net
# (C) 2000 Cobalt Networks, Inc., http://cobalt.com/, 2000
#
# User data reporting & backup.cgi interface

package Cobalt::UI::backupmenu;

use strict;
use Cobalt::Locale;
use Cobalt::Product;
use Locale::gettext;
use Cobalt::User;
use Cobalt::UI qw( get_style_info );
use CGI;

my $iam = '/cgi-bin/.cobalt/dispatch/backupmenu';

sub main {

my $q = shift; # CGI fields

###############
# who ami I? 
my $user = $ENV{'REMOTE_USER'};
my ($user_id, $user_dir) = (getpwnam($user))[2,7] if (($user =~ /^[a-z0-9][a-z0-9\.\-\_]+$/) && (length($user) < 32));
unless(-d $user_dir) { # such a physical validity test.  What are today's getpwnam exploits?
	die "Authenticated user $user does not have a home directory.  Aborting.\n";
}

# alteradmin becomes admin
if ($user eq $Alteradmin) {
	$user = $Adminuser;
}

###############
# render filename, note TGZ kinda like .tar.gz.  Any contents will work! 
# headerless, like it should be
my($filename, $date_stamp);
chomp($date_stamp = `date +%m-%d-%Y`);
$filename = $user.'-'.$date_stamp.'.tgz'; # Concat so perl doesn't confuse $'s

###############
# obtain local acct usage

# this times out with lots of files (sounds like a job for reiserfs)
# my $userUsage = `/usr/bin/du -sk $user_dir/ 2>&1`;

# since quota is always on for home just use this,
# since we currently only care about home anyways
my $userUsage = (user_show($user))[2, 3];

# Let's not forget the spool
my $mailSpool = "$Mailspool/$user";
my $mailSpool = "$Mailspool/$Adminuser" if ($user eq $Alteradmin);
my $userSpool = int((stat($mailSpool))[7]/1024) if (-e $mailSpool); 

$userSpool ||= 0.0;
$userUsage =~ s/^(\d+)\s*.*$/$1/ + $userSpool;
my( $archiveMin, $archiveMax ) = (int($userUsage*10/$BytesPerBlock)/20, int($userUsage*10/$BytesPerBlock)/10);
$archiveMax ||= '1.0';
my $user_error = $q->param('ERROR');
my $flav;
$flav = 'error' if ($user_error);

my $backup_button = <<EOF;
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0"><TR>
  <TD><A HREF="/cgi-bin/.cobalt/backup/backup.cgi" onMouseOver="status='[str.backup.start]'; return true;"><IMG SRC="/libImage/buttonLeftDot.gif" BORDER=0></A></TD>
  <TD NOWRAP STYLE="[FONTB]" ><A HREF="/cgi-bin/.cobalt/backup/backup.cgi" onMouseOver="status='[str.backup.start]'; return true;"><FONT STYLE="[FONTB]">[str.backup.start]</FONT></A></TD>
  <TD><A HREF="/cgi-bin/.cobalt/backup/backup.cgi" onMouseOver="status='[str.backup.start]'; return true;"><IMG SRC="/libImage/buttonRight.gif" BORDER=0></A></TD>
</TR></TABLE>
EOF

###############
# Report backup dataset
my $paths = $user_dir.'/*, <BR><FONT COLOR="#FFFFFF">&nbsp;</FONT>'."$mailSpool ($userSpool [str.backup.kilobytes])";

###############
# Test for too much data in personal account for http backup
if( $archiveMax > $MaxWebBackup) {
	$user_error = '[str.backup.too.much.data]';
	$flav = 'error'; 
	$backup_button = <<EOF;
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0"><TR>
  <TD><IMG SRC="/libImage/buttonLeftDot.gif" BORDER=0></TD>
  <TD NOWRAP STYLE="[FONTB]"><FONT STYLE="[FONTB]">[str.backup.start]</FONT></TD>
  <TD><IMG SRC="/libImage/buttonRight.gif" BORDER=0></TD>
</TR></TABLE>
EOF
}

my $style = get_style_info();

    my $locale = Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
    my $charset = $locale->getProperty("http_Charset");
    my $charsetText;
    if ($charset) {
	$charsetText = "; charset=$charset";
    }
    print "Content-type:  text/html$charsetText\nCache-Control: no-cache\n\n";
    undef($charset, $charsetText);

open(TMPL, "$Template_dir/backupmenu.tmpl") || die "Could not read template $Template_dir/personalbackup.tmpl: $!";
while(<TMPL>) {
	s/\[MIN\]/$archiveMin/;
	s/\[MAX\]/$archiveMax/;
	s/\[USERUSAGE\]/$userUsage/;
	s/\[BACKUPMAX\]/$MaxWebBackup/;
	s/\[USERERROR\]/$user_error/;
	s/\[FLAV\]/$flav/;
	s/\[BUTTON\]/$backup_button/;
	s/\[ARCHIVE\]/$filename/;
	s/\[PATHS\]/$paths/;

	s/\[FONTH\]/$style->{header}/g;
	s/\[FONTT\]/$style->{table}/g;
	s/\[FONTB\]/$style->{button}/g;

	s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/ge;
	print;
}
close(TMPL);

###############
# fin main()
}


########################## Subs

sub error {
        my $user_error = shift;
        $user_error =~ s/\s/\+/g;
        print "Location: /cgi-bin/.cobalt/turbo_ui/dispatch/backupmenu?USERERROR=$user_error\n\n";
        exit 0;
}



